// Initialize Canvas

canvas = document.getElementById("canvas");

ctx = canvas.getContext('2d');

var stage = new createjs.Stage("canvas");
var queue = new createjs.LoadQueue();

createjs.Touch.enable(stage);
stage.enableMouseOver();

queue.on("complete", handleComplete);
queue.loadManifest([
    { id: "andgate", src: "images/AND_GATE.png" },
    { id: "orgate", src: "images/OR_GATE.png" }

]);

var i0toand0 = new createjs.Shape();

var i1toand1 = new createjs.Shape();

var i2toand2 = new createjs.Shape();

var i3toand3 = new createjs.Shape();

var not1toand0and1 = new createjs.Shape();

var not0toand0and2 = new createjs.Shape();

var s1toand2and3 = new createjs.Shape();

var s0toand1and3 = new createjs.Shape();

var and0toor = new createjs.Shape();

var and1toor = new createjs.Shape();

var and2toor = new createjs.Shape();

var and3toor = new createjs.Shape();

var output = new createjs.Shape();

var Yletter, i0o, i0c, i1o, i1c, i2o, i2c, i3o, i3c, s1o, s1c, s0o, s0c;

var s1tonot1,s0tonot0;



function handleComplete() {


    var and0 = new createjs.Bitmap(queue.getResult("andgate"));
    and0.x = 459;
    and0.y = 71;
    and0.scaleX = 0.5;
    and0.scaleY = 0.5;
    stage.addChild(and0);

    var and1 = new createjs.Bitmap(queue.getResult("andgate"));
    and1.x = 459;
    and1.y = 161;
    and1.scaleX = 0.5;
    and1.scaleY = 0.5;
    stage.addChild(and1);

    var and2 = new createjs.Bitmap(queue.getResult("andgate"));
    and2.x = 459;
    and2.y = 251;
    and2.scaleX = 0.5;
    and2.scaleY = 0.5;
    stage.addChild(and2);

    var and3 = new createjs.Bitmap(queue.getResult("andgate"));
    and3.x = 459;
    and3.y = 341;
    and3.scaleX = 0.5;
    and3.scaleY = 0.5;
    stage.addChild(and3);

    var orgate = new createjs.Bitmap(queue.getResult("orgate"));
    orgate.x = 560;
    orgate.y = 210;
    orgate.scaleX = 0.47;
    orgate.scaleY = 0.47;
    stage.addChild(orgate);


    var vcc = new createjs.Shape();
    vcc.graphics.setStrokeStyle(4).beginStroke("red").moveTo(5, 28).lineTo(590, 28);
    vcc.graphics.moveTo(30, 28).lineTo(30, 630);
    vcc.graphics.moveTo(30, 68).lineTo(100, 68);
    vcc.graphics.beginStroke("black").setStrokeStyle(1).drawCircle(104, 68, 4);

    vcc.graphics.setStrokeStyle(4).beginStroke("red").moveTo(30, 157).lineTo(100, 157);
    vcc.graphics.beginStroke("black").setStrokeStyle(1).drawCircle(104, 157, 4);

    vcc.graphics.setStrokeStyle(4).beginStroke("red").moveTo(30, 246).lineTo(100, 246);
    vcc.graphics.beginStroke("black").setStrokeStyle(1).drawCircle(104, 246, 4);

    vcc.graphics.setStrokeStyle(4).beginStroke("red").moveTo(30, 338).lineTo(100, 338);
    vcc.graphics.beginStroke("black").setStrokeStyle(1).drawCircle(104, 338, 4);

    vcc.graphics.beginStroke("red").setStrokeStyle(4).moveTo(30, 630).lineTo(375, 630).lineTo(375, 595).endStroke().setStrokeStyle(1).beginStroke("black").drawCircle(375, 591, 4);
    vcc.graphics.beginStroke("red").setStrokeStyle(4).moveTo(250, 630).lineTo(250, 595).endStroke().setStrokeStyle(1).beginStroke("black").drawCircle(250, 591, 4);
    stage.addChild(vcc);

    var gnd = new createjs.Shape();
    gnd.graphics.setStrokeStyle(4).beginStroke("blue").moveTo(5, 650).lineTo(590, 650);
    gnd.graphics.moveTo(45, 650).lineTo(45, 98).lineTo(100, 98);
    gnd.graphics.beginStroke("black").setStrokeStyle(1).drawCircle(104, 98, 4);
    gnd.graphics.setStrokeStyle(4).beginStroke("blue").moveTo(280, 650).lineTo(280, 595).endStroke().setStrokeStyle(1).beginStroke("black").drawCircle(280, 591, 4);
    gnd.graphics.setStrokeStyle(4).beginStroke("blue").moveTo(405, 650).lineTo(405, 595).endStroke().setStrokeStyle(1).beginStroke("black").drawCircle(405, 591, 4);

    gnd.graphics.setStrokeStyle(4).beginStroke("blue").moveTo(45, 187).lineTo(100, 187);
    gnd.graphics.beginStroke("black").setStrokeStyle(1).drawCircle(104, 186, 4);

    gnd.graphics.setStrokeStyle(4).beginStroke("blue").moveTo(45, 278).lineTo(100, 278);
    gnd.graphics.beginStroke("black").setStrokeStyle(1).drawCircle(104, 277, 4);

    gnd.graphics.setStrokeStyle(4).beginStroke("blue").moveTo(45, 368).lineTo(100, 368);
    gnd.graphics.beginStroke("black").setStrokeStyle(1).drawCircle(104, 368, 4);

    stage.addChild(gnd);


    i0toand0.graphics.beginStroke("blue").drawCircle(145, 83, 4).moveTo(149, 83).lineTo(460, 83);
    stage.addChild(i0toand0);



    //

    i1toand1.graphics.beginStroke("black").drawCircle(145, 173, 4).endStroke().beginStroke("red").moveTo(149, 173).lineTo(460, 173);
    stage.addChild(i1toand1);


    i2toand2.graphics.beginStroke("black").drawCircle(145, 263, 4).endStroke().beginStroke("red").moveTo(149, 263).lineTo(460, 263);
    stage.addChild(i2toand2);
    //

    i3toand3.graphics.beginStroke("black").drawCircle(145, 353, 4).endStroke().beginStroke("blue").moveTo(149, 353).lineTo(460, 353);
    stage.addChild(i3toand3);


    var not0 = new createjs.Shape();
    not0.graphics.beginStroke("black").setStrokeStyle(2.5).moveTo(371, 501).lineTo(409, 501).lineTo(390, 470).lineTo(371, 501);
    not0.graphics.drawCircle(390, 466, 4);
    stage.addChild(not0);

    var not1=new createjs.Shape();
    not1.graphics.beginStroke("black").setStrokeStyle(2.5).moveTo(246, 501).lineTo(284, 501).lineTo(265, 470).lineTo(246, 501);
    not1.graphics.drawCircle(265, 466, 4);
    stage.addChild(not1);

    s1tonot1=new createjs.Shape();
    s1tonot1.graphics.setStrokeStyle(1).beginStroke("blue").drawCircle(265, 555, 4).moveTo(265, 551).lineTo(265, 501);
    stage.addChild(s1tonot1);

    s0tonot0=new createjs.Shape();
    s0tonot0.graphics.setStrokeStyle(1).beginStroke("red").drawCircle(390, 555, 4).moveTo(390, 551).lineTo(390, 501);
    stage.addChild(s0tonot0);


    
    s1toand2and3.graphics.beginStroke("blue").moveTo(265,520).lineTo(205,520).lineTo(205,289).lineTo(460,289).endStroke().beginFill("black").moveTo(205,369).drawCircle(205,369,4).endFill().beginStroke("blue").moveTo(209,369).lineTo(460,369);
    stage.addChild(s1toand2and3);

    s0toand1and3.graphics.beginStroke("red").moveTo(390,520).lineTo(330,520).lineTo(330,380).endStroke().beginFill("black").drawCircle(330,380,4).endFill().beginStroke("red").moveTo(334,380).lineTo(460,380).moveTo(330,376).lineTo(330,199).lineTo(460,199);
    stage.addChild(s0toand1and3);
    

    
    not1toand0and1.graphics.setStrokeStyle(1).beginStroke("red").moveTo(265, 462).lineTo(265, 96).lineTo(460, 96);
    not1toand0and1.graphics.endStroke().beginFill("black").drawCircle(265, 186, 4);
    not1toand0and1.graphics.beginStroke("red").moveTo(269, 186).lineTo(460, 186);
    stage.addChild(not1toand0and1);

    not0toand0and2.graphics.setStrokeStyle(1).beginStroke("blue").moveTo(390, 462).lineTo(390,276).endStroke().beginFill("black").drawCircle(390,276,4).endFill().beginStroke("blue").moveTo(394,276).lineTo(460,276).moveTo(390,276).lineTo(390,108).lineTo(460,108);
    stage.addChild(not0toand0and2);

    and0toor.graphics.setStrokeStyle(1).beginStroke("blue").moveTo(514, 98).lineTo(550, 98).lineTo(550, 226).lineTo(577, 226);
    stage.addChild(and0toor);

    and1toor.graphics.setStrokeStyle(1).beginStroke("red").moveTo(514, 188).lineTo(540, 188).lineTo(540, 239).lineTo(577, 239);
    stage.addChild(and1toor);

    and2toor.graphics.setStrokeStyle(1).beginStroke("blue").moveTo(514, 278).lineTo(532, 278).lineTo(532, 250).lineTo(577, 250);
    stage.addChild(and2toor);

    and3toor.graphics.setStrokeStyle(1).beginStroke("blue").moveTo(514, 368).lineTo(542, 368).lineTo(542, 262).lineTo(573, 262);
    stage.addChild(and3toor);

    output.graphics.setStrokeStyle(4).beginStroke("red").moveTo(618, 243).lineTo(670, 243);
    stage.addChild(output);


    var vcctext = new createjs.Text("Vcc", "19px Arial", "black");
    vcctext.x = 0;
    vcctext.y = 0;
    stage.addChild(vcctext);

    Yletter = new createjs.Text("Y = I1 = '1'", "19px Arial", "black");
    Yletter.x = 585;
    Yletter.y = 195;
    stage.addChild(Yletter);

    var I0text = new createjs.Text("I0", "19px Arial", "black");
    I0text.x = 118;
    I0text.y = 40;
    stage.addChild(I0text);

    var I1text = new createjs.Text("I1", "19px Arial", "black");
    I1text.x = 118;
    I1text.y = 130;
    stage.addChild(I1text);

    var I2text = new createjs.Text("I2", "19px Arial", "black");
    I2text.x = 118;
    I2text.y = 220;
    stage.addChild(I2text);

    var I3text = new createjs.Text("I3", "19px Arial", "black");
    I3text.x = 118;
    I3text.y = 310;
    stage.addChild(I3text);

    var S1text = new createjs.Text("S1", "19px Arial", "black");
    S1text.x = 210;
    S1text.y = 560;
    stage.addChild(S1text);

    var S0text = new createjs.Text("S0", "19px Arial", "black");
    S0text.x = 340;
    S0text.y = 560;
    stage.addChild(S0text);

    var GNDext = new createjs.Text("GND", "19px Arial", "black");
    GNDext.x = 0;
    GNDext.y = 660;
    stage.addChild(GNDext);

    i0c=new createjs.Shape();
    i0c.graphics.beginStroke("black").setStrokeStyle("2").moveTo(141,84).lineTo(109,68);
    stage.addChild(i0c);

    i0o=new createjs.Shape();
    i0o.graphics.beginStroke("black").setStrokeStyle("2").moveTo(141,84).lineTo(109,98);
    stage.addChild(i0o);

    //
    var hiti0 = new createjs.Shape();
    hiti0.graphics.beginFill("#000").drawRect(106, 65, 38, 38);
    i0o.hitArea = hiti0;
    i0c.hitArea = hiti0;


    i0o.cursor = "pointer";
    i0c.cursor = "pointer";
    

    i0o.on("click", handlei0);
    i0c.on("click", handlei0);
    //

    i1c=new createjs.Shape();
    i1c.graphics.beginStroke("black").setStrokeStyle("2").moveTo(141,174).lineTo(108,158);
    stage.addChild(i1c);

    i1o=new createjs.Shape();
    i1o.graphics.beginStroke("black").setStrokeStyle("2").moveTo(141,174).lineTo(108,187);
    stage.addChild(i1o);

    var hiti1 = new createjs.Shape();
    hiti1.graphics.beginFill("#000").drawRect(106, 155, 38, 38);
    i1o.hitArea = hiti1;
    i1c.hitArea = hiti1;


    i1o.cursor = "pointer";
    i1c.cursor = "pointer";
    

    i1o.on("click", handlei1);
    i1c.on("click", handlei1);

    //
    

    i2c=new createjs.Shape();
    i2c.graphics.beginStroke("black").setStrokeStyle("2").moveTo(141,263).lineTo(108,248);
    stage.addChild(i2c);

    i2o=new createjs.Shape();
    i2o.graphics.beginStroke("black").setStrokeStyle("2").moveTo(141,264).lineTo(108,277);
    stage.addChild(i2o);

    var hiti2 = new createjs.Shape();
    hiti2.graphics.beginFill("#000").drawRect(106, 242, 38, 40);
    i2o.hitArea = hiti2;
    i2c.hitArea = hiti2;


    i2o.cursor = "pointer";
    i2c.cursor = "pointer";
    

    i2o.on("click", handlei2);
    i2c.on("click", handlei2);



    //

    i3c=new createjs.Shape();
    i3c.graphics.beginStroke("black").setStrokeStyle("2").moveTo(141,353).lineTo(108,338);
    stage.addChild(i3c);

    i3o=new createjs.Shape();
    i3o.graphics.beginStroke("black").setStrokeStyle("2").moveTo(141,354).lineTo(108,367);
    stage.addChild(i3o);

    var hiti3 = new createjs.Shape();
    hiti3.graphics.beginFill("#000").drawRect(106, 334, 38, 40);
    i3o.hitArea = hiti3;
    i3c.hitArea = hiti3;


    i3o.cursor = "pointer";
    i3c.cursor = "pointer";
    

    i3o.on("click", handlei3);
    i3c.on("click", handlei3);

    //

    s1c=new createjs.Shape();
    s1c.graphics.beginStroke("black").setStrokeStyle("2").moveTo(265,558).lineTo(250,587);
    

    s1o=new createjs.Shape();
    s1o.graphics.beginStroke("black").setStrokeStyle("2").moveTo(265,558).lineTo(280,587);
    

    //

    var hits1 = new createjs.Shape();
    hits1.graphics.beginFill("#000").drawRect(242, 552, 38, 39);
    s1o.hitArea = hits1;
    s1c.hitArea = hits1;


    s1o.cursor = "pointer";
    s1c.cursor = "pointer";
    

    s1o.on("click", handles1);
    s1c.on("click", handles1);

    stage.addChild(s1c);
    stage.addChild(s1o);
    
    //


    s0c=new createjs.Shape();
    s0c.graphics.beginStroke("black").setStrokeStyle("2").moveTo(390,558).lineTo(376,587);
    stage.addChild(s0c);

    s0o=new createjs.Shape();
    s0o.graphics.beginStroke("black").setStrokeStyle("2").moveTo(390,558).lineTo(405,587);
    stage.addChild(s0o);

    var hits0 = new createjs.Shape();
    hits0.graphics.beginFill("#000").drawRect(372, 554, 38, 38);
    s0o.hitArea = hits0;
    s0c.hitArea = hits0;


    s0o.cursor = "pointer";
    s0c.cursor = "pointer";
    

    s0o.on("click", handles0);
    s0c.on("click", handles0);

    //



    //
    s1o.visible=true;
    s1c.visible=false;

    s0o.visible=false;
    s0c.visible=true;

    i1c.visible=true;
    i1o.visible=false;

    i0o.visible=true;
    i0c.visible=false;

    i2c.visible=true;
    i2o.visible=false;

    i3o.visible=true;
    i3c.visible=false;

    $("#s1").prop("checked",false);
    $("#s0").prop("checked",true);

    $("#i0").prop("checked",false);
    $("#i1").prop("checked",true);

    $("#i2").prop("checked",true);
    $("#i3").prop("checked",false);


 
    



    stage.update();



}